#include <Carbon/Carbon.h>

void hack_macos_app_to_foreground(int stayback)
{
	OSErr err;
	OSStatus status;
	CFDictionaryRef dict;
	int bg_only = -1;
	ProcessSerialNumber psn = { 0, kCurrentProcess };

	dict = ProcessInformationCopyDictionary(&psn, kProcessDictionaryIncludeAllInformationMask);
	if (dict) {
		CFBooleanRef br;
		br = CFDictionaryGetValue(dict, CFSTR("LSBackgroundOnly"));
		if (br) bg_only = CFBooleanGetValue(br);
		CFRelease(dict);
	}

	if (!bg_only) {
		if (!stayback) {
			fputs("Bringing front\n", stderr);
			err = SetFrontProcess(&psn);
		}
		return;
	}

	fputs("Changing to foreground and bringing front\n", stderr);
	status = TransformProcessType(&psn, kProcessTransformToForegroundApplication);
	err = SetFrontProcess(&psn);
}
