#include <AppKit/AppKit.h>
#include "RawApplication.h"

@implementation RawApplication
-(void)setKeyView:(NSView *)keyView
{
	_view = keyView;
}

-(void)sendEvent:(NSEvent *)anEvent
{
	if (_view) {
		switch ([anEvent type]) {
		case NSFlagsChanged:
			[_view flagsChanged:anEvent];
			break;
		case NSKeyDown:
			[_view keyDown:anEvent];
			break;
		default:
			break;
		}
	}

	[super sendEvent:anEvent];
}
@end
